LoginLayer = class("LoginLayer")
LoginLayer.__index = LoginLayer

LoginLayer.topNode = nil
LoginLayer.editbox = nil

ccb["LoginLayer"] = LoginLayer
LoginLayerOwner = LoginLayerOwner or {}
ccb["LoginLayerOwner"] = LoginLayerOwner

LoginLayer.loginRegionShowLayer = nil
LoginLayer.filterLayer = nil	
LoginLayer.filterScroll = nil	--下面的滚动层
LoginLayer.RegionInfo = nil
LoginLayer.LoginRegion = 1 
LoginLayer.selectRegionTitle = nil
LoginLayer.hedeLoginSdk = nil
LoginLayer.curGameVersion = ""
local hedeLoginSdk = {}

SDK_PLATFORM = ""
LOGIN_SERVER_ID = 1
LOGIN_SERVER_NAME = ""
LOGIN_GAME_SERVER_1 = ""
LOGIN_GAME_SERVER_2 = ""
SERVER_ADDRESS = nil
NOTICE_ID = 1
TESTUSERID = 1
QH_360_USERID = ""
ACCESS_TOKEN = ""

function canBuy()
	-- body
	if SDK_PLATFORM == "SDK_WEIBO_IOS" then
    	if DevicePlatform:getInstance():getDeviceToken() == "" then
    		return false
    	end
    end
    return true
end
  
local function showHedeChina()
	LoginLayer.hedeLoginSdk = LoginLayerOwner["mHedeSdkLogin"]
	LoginLayer.hedeLoginSdk:setVisible(true)
	LoginLayerOwner["mLoginEnterGameBtn"]:setVisible(false)
	LoginLayerOwner["mUserAcountLayer"]:setVisible(false)
	LoginLayerOwner["mLoginRegionShowLayer"]:setVisible(false)
end
--登陆验证

local function enableLoginTouch(isEnable)
  	tolua.cast(LoginLayerOwner["mLoginEnterGameBtn"], "cc.ControlButton"):setEnabled(isEnable)
	LoginLayer.editbox:setEnabled(isEnable)
	if SDK_PLATFORM ~= SDK_XM_ANDROID then
       tolua.cast(LoginLayerOwner["mLoginEnterGameBtn"], "cc.ControlButton"):setEnabled(true)
    end
end

local function hideHedeChina()
	LoginLayer.hedeLoginSdk = LoginLayerOwner["mHedeSdkLogin"]
	LoginLayer.hedeLoginSdk:setVisible(false)
	LoginLayerOwner["mLoginEnterGameBtn"]:setVisible(true)
	LoginLayerOwner["mUserAcountLayer"]:setVisible(true)
	LoginLayerOwner["mLoginRegionShowLayer"]:setVisible(true)
end

local function sendLoginGameRequest(token,uid,platform)
	print("sendLoginGameRequest", token, uid, platform)
    local function loginRequestCallback(jsonDataTable)
	    if jsonDataTable.ret ~= 0 then
		    cclog("login failed %d", jsonDataTable.ret)
			if jsonDataTable.ret >= 9001 and jsonDataTable.ret <= 9004 then
				CreateSmallPopupWithCancel(nil,CreateCommonLabel(MultiLan("error_"..jsonDataTable.ret), nil,FontSize3))
			else
				CommonCreatePopupSmallWithOneButtonCallback(nil, CreateCommonLabel(MultiLan("httpreq_desc1"), nil, FontSize3), MultiLan("button_retry"), useSdkForLogin)
			end
			
		    return 
	    end
	
	    USER_TOKEN = jsonDataTable.data.token
	    cclog("user id is %s", USER_TOKEN)
        local havegetRegion  = false
        if LoginLayer.RegionInfo ~= nil then
           havegetRegion = true
        end
        LoginLayer.RegionInfo = jsonDataTable.data.server_list
        LoginLayer:regionScrollRefresh()
		if LOGIN_SERVER_ID > 0 then
			for i=1, table.maxn(LoginLayer.RegionInfo) do
				if LoginLayer.RegionInfo[i].id == LOGIN_SERVER_ID then
					LOGIN_SERVER_NAME = LoginLayer.RegionInfo[i].name
				end
			end
		end
		if SDK_PLATFORM ==  "SDK_WEIBO_IOS" then
			hideHedeChina()
		end
        enableLoginTouch(true)
		print("havegetRegion", havegetRegion, SDK_PLATFORM)
        if havegetRegion == true and SDK_PLATFORM == "SDK_NONE" then
           onLoginEnterGame()
        end
		
		if SDK_PLATFORM == "SDK_QH_ANDROID" or SDK_PLATFORM == "SDK_COOLPAD_ANDROID" then	
		    QH_360_USERID = jsonDataTable.data.open_id
			
			if SDK_PLATFORM == "SDK_COOLPAD_ANDROID" then
				ACCESS_TOKEN = jsonDataTable.data.access_token
				cclog("coolpad access token : " .. ACCESS_TOKEN)
			end
			
			if  false then
              local tmpTable = {qhExtFun = 1, ExtFunRoleId = QH_360_USERID}
		      DevicePlatform:getInstance():sdkExtraFunction(tmpTable)
		    end
			tolua.cast(LoginLayerOwner["mLoginUsrAcountId"], "cc.Label"):setString(QH_360_USERID)
		elseif SDK_PLATFORM ~= "SDK_NONE" then
			tolua.cast(LoginLayerOwner["mLoginUsrAcountId"], "cc.Label"):setString(jsonDataTable.data.open_id)
		end
		
    end
    cclog("sendLoginGameRequest")
	
 --    if SDK_PLATFORM ~= "SDK_NONE" and DevicePlatform:getInstance():getDeviceToken() == ""  and SDK_PLATFORM ~= "SDK_WEIBO_IOS"then
	--     CommonNote("FAILED")
 --        enableLoginTouch(true)
 --        return
	-- end
	print("-----istrue"..tostring(SDK_PLATFORM == "SDK_WEIBO_IOS"))
	if SDK_PLATFORM == "SDK_XY_IOS" or SDK_PLATFORM == "SDK_TGAME_IOS" or 
		SDK_PLATFORM == "SDK_TGAME_ANDROID" or SDK_PLATFORM == "SDK_BAIDU_ANDROID" or 
		SDK_PLATFORM == "SDK_OPPO_ANDROID" or SDK_PLATFORM == "SDK_XM_ANDROID" or 
		SDK_PLATFORM == "SDK_TGAME_VN_IOS" or SDK_PLATFORM == "SDK_TGAME_VN_ANDROID" or 
		SDK_PLATFORM == "SDK_TGAME_TH_IOS" or SDK_PLATFORM == "SDK_TGAME_TH_ANDROID" or
		SDK_PLATFORM == "SDK_TGAME_XMT_IOS" or SDK_PLATFORM == "SDK_TGAME_XMT_ANDROID" or 
		SDK_PLATFORM == "SDK_WDJ_ANDROID" or SDK_PLATFORM == "SDK_COOLPAD_ANDROID" or 
		SDK_PLATFORM == "SDK_ANZHI_ANDROID"or  SDK_PLATFORM == "SDK_JAGUAR_ANDROID" or 
		SDK_PLATFORM == "SDK_JAGUAR_THIRD" then
        HttpSend("game/login", {"game=guaji", "token=" .. token, "uid="..uid, "platform="..platform}, loginRequestCallback)
    elseif SDK_PLATFORM == "SDK_WEIBO_IOS" or SDK_PLATFORM == "SDK_LOVEU_ANDROID" then
    	-- local deviceid = DevicePlatform:getInstance():getDeviceInfomation()
    	local deviceid = DevicePlatform:getInstance():getDeviceID()
    	print("---deviceid2---"..deviceid)
    	  HttpSend("game/login", {"game=guaji", "token=" .. token, "uid="..uid, "platform="..platform, "device_id="..deviceid}, loginRequestCallback)
    else
        HttpSend("game/login", {"game=guaji", "token=" .. token, "platform="..platform}, loginRequestCallback)
    end

	
end

function TGameLogout(event)
	-- body
end

function useSdkForLogin(event)
    cclog("user sdk login")
	sendLoginGameRequest(DevicePlatform:getInstance():getDeviceToken(),DevicePlatform:getInstance():getDeviceID(),SDK_PLATFORM)
end

function startGameLogin()
    cclog("startGameLogin")
    LOGIN_SERVER_ID = cc.UserDefault:getInstance():getIntegerForKey("ServerId")
	print(LOGIN_SERVER_ID)
    LOGIN_GAME_SERVER_1 = ""
    LOGIN_GAME_SERVER_2 = ""

    if SDK_PLATFORM == "SDK_NONE" then
   	    TESTUSERID = tonumber(tolua.cast(LoginLayer.editbox,"cc.EditBox"):getText())

	    if TESTUSERID ~= nil then
            enableLoginTouch(false)
            sendLoginGameRequest(TESTUSERID,DevicePlatform:getInstance():getDeviceID(),SDK_PLATFORM)
	    end
    else
    	local eventDispatcher  = cc.Director:getInstance():getEventDispatcher()
	    local eventName = "TGameLogoutEvent"
	    local listener = cc.EventListenerCustom:create(eventName, gameEntranceDelay)
	    eventDispatcher.addEventListenerWithFixedPriority(eventDispatcher,listener, 1)
        DevicePlatform:getInstance():showLogin()
        enableLoginTouch(false)
    end

end

function onLoginSwitchAccountClicked()
	if SDK_PLATFORM ~= "SDK_NONE" then
		if SDK_PLATFORM == "SDK_TGAME_ANDROID" or SDK_PLATFORM ==  "SDK_JAGUAR_ANDROID" or SDK_PLATFORM  == "SDK_JAGUAR_THIRD" then
			 DevicePlatform:getInstance():logout()
		end
		if SDK_PLATFORM == "SDK_WEIBO_IOS" then
			showHedeChina()
		else
	    	DevicePlatform:getInstance():showLogin()
	    end
        	enableLoginTouch(false)
		 --local tmpTable = {qhExtFun = 1}
		--DevicePlatform:getInstance():sdkExtraFunction(qhExtFun)
	end
end


function onLoginEnterGame()
	print("onLoginEnterGame")
    --异常处理
    if  LoginLayer.RegionInfo == nil then
       return
    end

    if  SDK_PLATFORM == "SDK_NONE" and TESTUSERID  ~=  tonumber(tolua.cast(LoginLayer.editbox,"cc.EditBox"):getText()) then
       	local userId = tonumber(tolua.cast(LoginLayer.editbox,"cc.EditBox"):getText())
	    if userId ~= nil then
            enableLoginTouch(false)
            sendLoginGameRequest(userId,DevicePlatform:getInstance():getDeviceID(),SDK_PLATFORM)
            TESTUSERID = userId
	    end
        return
    end
	
	-- if SDK_PLATFORM ~= "SDK_NONE" and DevicePlatform:getInstance():getDeviceToken() == "" then
	-- 	if not (SDK_PLATFORM == "SDK_WEIBO_IOS" and  USER_TOKEN ~= "") then
	--    	 	DevicePlatform:getInstance():showLogin()
 --        	return
 --        end
	-- end

    --进入游戏
	local function loginEnterGameCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("login enter game failed %d", jsonDataTable.ret)
			return 
		end
		cclog("login enter game ok")
		GameEnteringLayer.percent = GameEnteringLayer.REQUEST_USER_INFO
		onLoginGetUserInfo()
	end

	SERVER_ADDRESS = LOGIN_GAME_SERVER_1
    local index = string.find(LOGIN_GAME_SERVER_2, ":")
    GameConfig:SetChatReginAddress(string.sub(LOGIN_GAME_SERVER_2, 1, index-1),string.sub(LOGIN_GAME_SERVER_2, index+1, -1))
    cc.UserDefault:getInstance():setIntegerForKey("ServerId", LOGIN_SERVER_ID)
	HttpSend("game/main", {"sid="..LOGIN_SERVER_ID,"device_info="..DevicePlatform:getInstance():getDeviceInfomation()}, loginEnterGameCallback)

	GameEnteringLayer:GameEnteringLayerEnter()
	LoginLayer.topNode:setVisible(false)
end

function onLoginGetUserInfo()
	local function onLoginGetUserInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("login get user info failed %d", jsonDataTable.ret)
			return 
		end
		cclog("login get user info ok")
		UserInfo:setUserInfo(jsonDataTable)
		InitTimeDownSchedule()
		GameEnteringLayer.percent = GameEnteringLayer.PREPARE_USER_INFO
		LoginLayer:LoginLayerExit()
		if UserInfo:getUserInfo().data.info.role == 0 then
		    GameGuide:AttentionGuide()
			LoginRegisterLayer:LoginRegisterLayerEnter()
		else
			--获取用户信息后初始化
			DelayTimeCallfunc(scene, 0.01, InitGameUi)
		end
	end
	HttpSend("user/info", {}, onLoginGetUserInfoCallback)
end

function onLoginRegionClicked()
	if LoginLayer.RegionInfo == nil or table.maxn(LoginLayer.RegionInfo) == 0 then
		return
	end
    if LoginLayer.filterLayer == nil then
       LoginLayer:creatRegionScroll()
    end
    local isshowLoginRegion = LoginLayer.filterLayer:getParent():isVisible()
    isshowLoginRegion = not isshowLoginRegion
    LoginLayer:showLoginRegionAction(isshowLoginRegion)
end
local function ininHedeChina()
	-- body
	showHedeChina()
end

----------------------------------------------------
----------------------------------------------------
function LoginLayer:LoginLayerEnter()
	NOTICE_ID = IHelper:getInstance():getNoticeId()
	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/Login.ccbi",proxy,LoginLayerOwner)
	scene:addChild(self.topNode)
	AddCloudForBackground(LoginLayerOwner["mLoginBack"],1)
	-- LoginLayerOwner["mLoginDesc1"]:setString(MultiLan("login_desc1"))
	LoginLayerOwner["mLoginDesc2"]:setString(MultiLan("login_desc2"))
	LoginLayerOwner["mLoginDesc3"]:setString(MultiLan("login_desc3"))
	LoginLayerOwner["mButtonChange"]:setTitleForState(MultiLan("login_desc4"),1)
	LoginLayerOwner["mLoginDesc5"]:setString(MultiLan("login_desc5"))

	LoginLayerOwner["mLoginEnterGameLabel"]:setString(ZGMultiLan("login_btn_start_game"))
	CommonMoveLabelUnderBtn(LoginLayerOwner["mLoginEnterGameBtn"], LoginLayerOwner["mLoginEnterGameLabel"])
	
	self.editbox = cc.EditBox:create(cc.size(150, 40), cc.Scale9Sprite:createWithSpriteFrameName("board_account01.png"))
	local editLayer = LoginLayerOwner["mLoginLayerAccount"]
	editLayer:addChild(self.editbox)
	self.editbox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
	self.editbox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	self.editbox:setText("1987")
	self.editbox:setPosition(cc.p(editLayer:getContentSize().width / 2, editLayer:getContentSize().height / 2))
	
	--版本号显示
	self.curGameVersion = IHelper:getInstance():getFinalVersion()
	print(self.curGameVersion)
	LoginLayerOwner["mLoginCurVersion"]:setString(MultiLan("login_desc7")..self.curGameVersion)
    --登录相关
    local eventDispatcher  = cc.Director:getInstance():getEventDispatcher()
    local eventName = "NotificationDeviceIdReady"
    local listener = cc.EventListenerCustom:create(eventName, useSdkForLogin)
    eventDispatcher.addEventListenerWithFixedPriority(eventDispatcher,listener, 1)

    SDK_PLATFORM = DevicePlatform:getInstance():getSdkPlatform() -- "SDK_NONE"--DevicePlatform:getInstance():getSdkPlatform()
	if SDK_PLATFORM ~= "SDK_NONE" then
		editLayer:setVisible(false)
	else
		LoginLayerOwner["mButtonChange"]:setVisible(false)
	end
	LoginLayerOwner["mUserAcountLayer"]:setVisible(false)
	if SDK_PLATFORM == "SDK_WDJ_ANDROID" then
		LoginLayerOwner["mButtonChange"]:setVisible(false)
	end
	if SDK_PLATFORM == "SDK_LOVEU_ANDROID" then
		LoginLayerOwner["mButtonChange"]:setVisible(false)
	end
    self.creatRegionScroll()
    if SDK_PLATFORM ==  "SDK_WEIBO_IOS" then
    	ininHedeChina()
    else
    	startGameLogin()
    end
	
	M.init()
	M.playMusic("sound/bgm.mp3", true)
	
	GameNoticeShow()
end

function LoginLayer:LoginLayerExit()
   cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("NotificationDeviceIdReady")
end
------------------------------------------------------------------------
-- -- 大区选择
function LoginLayer:onRegionChooseFun(node)
    if node == nil then
      node = self
    end
    LoginLayer.LoginRegion = node:getTag()

    tolua.cast(LoginLayer.selectRegionTitle, "cc.ControlButton"):
    setTitleForState(LoginLayer.RegionInfo[LoginLayer.LoginRegion].name..
                                      MultiLan( "sever_state_"..LoginLayer.RegionInfo[LoginLayer.LoginRegion].state),1)

    LoginLayer:showLoginRegionAction(false)

    LOGIN_SERVER_ID = LoginLayer.RegionInfo[LoginLayer.LoginRegion].id
	LOGIN_SERVER_NAME = LoginLayer.RegionInfo[LoginLayer.LoginRegion].name 
    LOGIN_GAME_SERVER_1 = "http://"..LoginLayer.RegionInfo[LoginLayer.LoginRegion].game_server1.."/"
    LOGIN_GAME_SERVER_2 = LoginLayer.RegionInfo[LoginLayer.LoginRegion].game_server2 

end

function LoginLayer:creatRegionScroll()
    LoginLayer.filterLayer = tolua.cast(LoginLayerOwner["mLoginRegionFilter"], "cc.Layer")
    LoginLayer.selectRegionTitle = LoginLayerOwner["mSelectRegionTitle"]
    LoginLayer.loginRegionShowLayer = LoginLayerOwner["mLoginRegionShowLayer"]
    LoginLayer.loginRegionShowLayer:setVisible(true)
    LoginLayer.filterLayer:getParent():setVisible(false)

	LoginLayer.filterScroll = cc.ScrollView:create()
	LoginLayer.filterLayer:addChild(LoginLayer.filterScroll)
	LoginLayer.filterScroll:setViewSize(cc.size(LoginLayer.filterLayer:getContentSize().width, LoginLayer.filterLayer:getContentSize().height))
	LoginLayer.filterScroll:setPosition(cc.p(0,0))
	LoginLayer.filterScroll:ignoreAnchorPointForPosition(true)
	LoginLayer.filterScroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	LoginLayer.filterScroll:setClippingToBounds(true)
	LoginLayer.filterScroll:setBounceable(true)
	LoginLayer.filterScroll:setDelegate()
	LoginLayer.filterScroll:setVisible(true)

end

function LoginLayer:regionScrollRefresh()
	if LOGIN_SERVER_ID == 0 then
		LOGIN_SERVER_ID = LoginLayer.RegionInfo[table.maxn(LoginLayer.RegionInfo)].id--LoginLayer.RegionInfo[1].id
		LOGIN_SERVER_NAME = LoginLayer.RegionInfo[table.maxn(LoginLayer.RegionInfo)].name 
	end

   local serverIndex = table.maxn(LoginLayer.RegionInfo)
   while serverIndex>=1 do
       if LoginLayer.RegionInfo[serverIndex].id == LOGIN_SERVER_ID then
          break
       end
       serverIndex = serverIndex - 1
   end
   if serverIndex < 1 then
      serverIndex = 1
      LOGIN_SERVER_ID = LoginLayer.RegionInfo[serverIndex].id
	  LOGIN_SERVER_NAME = LoginLayer.RegionInfo[serverIndex].name 
   end
   LOGIN_GAME_SERVER_1 = "http://"..LoginLayer.RegionInfo[serverIndex].game_server1.."/"
   LOGIN_GAME_SERVER_2 = LoginLayer.RegionInfo[serverIndex].game_server2

   tolua.cast(LoginLayer.selectRegionTitle, "cc.ControlButton"):
   setTitleForState(LoginLayer.RegionInfo[serverIndex].name..
                       MultiLan("sever_state_"..LoginLayer.RegionInfo[serverIndex].state),1)

	local scrollLayer = cc.Layer:create()
	scrollLayer:ignoreAnchorPointForPosition(true)
	LoginLayer.filterScroll:setContainer(scrollLayer)
	local scrollWorldPos = LoginLayer.filterScroll:getParent():convertToWorldSpace(cc.p(LoginLayer.filterScroll:getPosition()))
	local scrollViewSize = LoginLayer.filterScroll:getViewSize()
	local curPosY = 0

	local i = 1
	while i <= table.maxn(LoginLayer.RegionInfo) do
		local itemLayer = CreateLoginRegionItem()
		itemLayer:ignoreAnchorPointForPosition(true)
		itemLayer:setTag(i)
        itemLayer:setExternFun(LoginLayer.onRegionChooseFun)

        local itemBgSprite = cc.Sprite:createWithSpriteFrameName("button_otherserver.png")
	    itemBgSprite:setAnchorPoint(cc.p(0, 0))
	    itemLayer:addChild(itemBgSprite)
        
        local regionTitle = cc.Label:create(LoginLayer.RegionInfo[i].name..
		                          MultiLan("sever_state_"..LoginLayer.RegionInfo[i].state), DefaultFontName, FontSize3)
        if LoginLayer.RegionInfo[i].state == 0 then
		    regionTitle:setColor(COLOR_GREEN)
	    elseif LoginLayer.RegionInfo[i].state == 1 then
		     regionTitle:setColor(COLOR_RED)
	    end
        regionTitle:setPosition(cc.p(itemBgSprite:getContentSize().width/2, itemBgSprite:getContentSize().height/2))
        itemLayer:addChild(regionTitle)  
             	
		itemLayer:setContentSize(itemBgSprite:getContentSize())
		itemLayer:setPosition(cc.p(4, curPosY))
		curPosY = curPosY + itemLayer:getContentSize().height + 8

		scrollLayer:addChild(itemLayer)
	
		i = i+1
	end

	if scrollLayer:getContentSize().height <= LoginLayer.filterLayer:getContentSize().height then
		scrollLayer:setContentSize(cc.size(LoginLayer.filterLayer:getContentSize().width, LoginLayer.filterLayer:getContentSize().height))
		LoginLayer.filterScroll:setContentOffset(cc.p(0, 0), false)
	else
		scrollLayer:setContentSize(cc.size(LoginLayer.filterLayer:getContentSize().width, curPosY))
		LoginLayer.filterScroll:setContentOffset(cc.p(0, -scrollLayer:getContentSize().height + LoginLayer.filterScroll:getViewSize().height), false)
	end
	LoginLayer.filterScroll:updateInset()
end

function LoginLayer:showLoginRegionAction(isShow)

   LoginLayer.filterLayer:getParent():setVisible(isShow)
   LoginLayerOwner["mLoginEnterGameBtn"]:setVisible(not isShow)
   if isShow == true then
       LoginLayer.loginRegionShowLayer:setPositionY(LoginLayer.loginRegionShowLayer:getPositionY() + 260)
   else
       LoginLayer.loginRegionShowLayer:setPositionY(LoginLayer.loginRegionShowLayer:getPositionY() - 260)
   end
end

local function onHedeGuestLogin( ... )
	-- body
	sendLoginGameRequest(DevicePlatform:getInstance():getDeviceToken(),DevicePlatform:getInstance():getDeviceID(),SDK_PLATFORM)
end

local function onHedeWeiboLogin( ... )
	-- body
	startGameLogin()
end
------------------------------------------------------------------------
--

LoginLayer["onLoginEnterGame"] = onLoginEnterGame
LoginLayer["onLoginRegionClicked"] = onLoginRegionClicked
LoginLayer["onLoginSwitchAccountClicked"] = onLoginSwitchAccountClicked
LoginLayer["onHedeGuestLogin"] = onHedeGuestLogin
LoginLayer["onHedeWeiboLogin"] = onHedeWeiboLogin