
local bShopInited = false
local LuckShopLock = false
local shopScrollLayer = nil
local shopScrollView = nil
UserShopInfo = nil

function SetCommonMoneyLayer()
	print("k1")
    tolua.cast(XiaLayerOwner["mCommonMoneyLevel"],"cc.Label"):setString("Lv."..UserSelfInfo.level)
	print("k2")
	tolua.cast(XiaLayerOwner["mCommonMoneyGold"],"cc.Label"):setString(UserSelfInfo.gold)
	tolua.cast(XiaLayerOwner["mCommonMoneyCash"],"cc.Label"):setString(UserSelfInfo.cash)
	tolua.cast(XiaLayerOwner["mCommonMoneyVip"],"cc.Label"):setString(UserSelfInfo.vip)
end

--购买回掉
local function shopBuyCallback(jsonDataTable)
	if jsonDataTable.ret ~= 0 then
		cclog("shopBuyCallback failed %d", jsonDataTable.ret)
		return 
	end
	print("shopBuyCallback",table.maxn(jsonDataTable.data.item))
	--增加
	UserInfo:addProp(jsonDataTable.data.item)
	
	local num = 0
	
	local line = math.ceil(table.maxn(UserShopInfo.info.list)/3)
	LuckShopLock = true
	local function deleteItem()
		print("deleteItem",num,table.maxn(jsonDataTable.data.buy))
		num = num + 1
		M.playEffect("sound/buy_succeed.mp3")
		for i=1,table.maxn(UserShopInfo.info.list) do
			if UserShopInfo.info.list[i].id == jsonDataTable.data.buy[num] and UserShopInfo.info.list[i].button ~= nil then
				removeSelf(UserShopInfo.info.list[i].layer)
				table.remove(UserShopInfo.info.list, i)
				print("remove", i, table.maxn(UserShopInfo.info.list))
				--重排位置
				local count = table.maxn(UserShopInfo.info.list)
				print("count", count, line)
				local tempLine = math.ceil(table.maxn(UserShopInfo.info.list)/3)
				shopScrollLayer:setContentSize(cc.size(600, math.max(535, 250*tempLine-20)))
				shopScrollView:setContentOffset(cc.p(0, 535-(250*tempLine-20)))
				if 250  * tempLine - 20 < 535 then
					shopScrollView:setTouchEnabled(false)
				end
				
				for j=1,tempLine do
					for k=1,3 do
						local p = (j-1)*3 + k
						if UserShopInfo.info.list[p] ~= nil and UserShopInfo.info.list[p].button ~= nil then
							UserShopInfo.info.list[p].layer:setPosition(cc.p(200*k-100, 250 * (tempLine-j+1) - 140))
							UserShopInfo.info.list[p].button:setTag(p)
						end
					end
				end
				

				
				if jsonDataTable.data.newinfo ~= nil and num == table.maxn(jsonDataTable.data.buy) then
					UserShopInfo.info.list = jsonDataTable.data.newinfo.list
					table.sort(UserShopInfo.info.list,SortTableById)
					ShopUpdateList()
				end
				if num == table.maxn(jsonDataTable.data.buy) then
					LuckShopLock = false
				end
				
				break
			end
		end
	end
	
	--飘字
	local noteArr = {}
	for i=1, table.maxn(jsonDataTable.data.buy) do
		for j=1,table.maxn(UserShopInfo.info.list) do
			if UserShopInfo.info.list[j].id == jsonDataTable.data.buy[i] then
				table.insert(noteArr, string.format(MultiLan("shop_desc1"), MultiLan(GameData:getPropDataTable(UserShopInfo.info.list[j].prop_id).name)))
				break
			end
		end
	end
	
	--for i=1, table.maxn(jsonDataTable.data.item) do
	--	table.insert(noteArr, "购买 ".. (jsonDataTable.data.item[i].prop_id).name.." 成功")
	--end
	if table.maxn(noteArr) == 1 then
		CommonNote(noteArr,nil,deleteItem)
	else
		CommonNote(noteArr,nil,deleteItem,0.2)
	end
	
	--消耗
	for i=1,table.maxn(jsonDataTable.data.use) do
		UserSelfInfo[jsonDataTable.data.use[i].use_type] = UserSelfInfo[jsonDataTable.data.use[i].use_type] - jsonDataTable.data.use[i].use_num
		if jsonDataTable.data.use[i].use_type == "cash" then
			UseCash(jsonDataTable.data.use[i].use_num)
		end
	end
	
	--幸运值
	UserShopInfo.luck = jsonDataTable.data.luck

	--刷新
	--[[
	if jsonDataTable.data.newinfo ~= nil then
		UserShopInfo.info.list = jsonDataTable.data.newinfo.list
		print("new",table.maxn(jsonDataTable.data.newinfo.list))
		table.sort(UserShopInfo.info.list,SortTableById)
	else --删除已购买商品
		print("delete",table.maxn(jsonDataTable.data.buy))
		for i=1, table.maxn(jsonDataTable.data.buy) do
			for j=1,table.maxn(UserShopInfo.info.list) do
				if UserShopInfo.info.list[j].id == jsonDataTable.data.buy[i] then
					print("find", i ,j)
					table.remove(UserShopInfo.info.list, j)
					break
				end
			end
		end
	end
	]]
	SetCommonMoneyLayer()
	
	
end

local function onItemClicked(node)
	if LuckShopLock then
		return
	end

	local tag = tolua.cast(node,"cc.Node"):getTag()
	print("onItemClicked",tag,table.maxn(UserShopInfo.info.list))
	if UserSelfInfo.vip == 0 and UserShopInfo.info.list[tag].id == 1 then
		CommonNote(MultiLan("shop_desc2"))
		return
	end
	
	if UserShopInfo.info.list[tag].type == 1 and UserSelfInfo.gold < UserShopInfo.info.list[tag].cost then
		CommonGoldNeed()
		return
	elseif UserShopInfo.info.list[tag].type == 2 and UserSelfInfo.cash < UserShopInfo.info.list[tag].cost then
		CommonCashNeed()
		return
	elseif UserShopInfo.info.list[tag].type == 6 and UserSelfInfo.coupon < UserShopInfo.info.list[tag].cost then
		CommonCouponNeed()
		return
	end
	HttpSend("shop/buy", {"id=3", "itemid="..UserShopInfo.info.list[tag].id}, shopBuyCallback)
end

--刷新商品的信息
function ShopUpdateList()
	print("ShopUpdateList")
	XiaLayerOwner["mShopLuckLabel"]:setString(UserShopInfo.luck)
	
	local layer = cc.Layer:create()
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mShopScrollLayer"], layer, cc.p(0,0), kScrollViewDirectionVertical)
	local line = math.ceil(table.maxn(UserShopInfo.info.list)/3)
	local scrollWorldPos = XiaLayerOwner["mShopScrollLayer"]:convertToWorldSpace(cc.p(scrolView:getPosition()))
	local scrollViewSize = scrolView:getViewSize()
	local y = 250 * line - 140
	for i=1, line do
		for j=1,3 do
			local x = 200*j-100
			local itemInfo = UserShopInfo.info.list[(i-1)*3+j]
			if itemInfo ~= nil then
				local back = CreateLayer(cc.size(200,250),1,cc.p(x, y))
				itemInfo.layer = back
				layer:addChild(back)
			
				back:addChild(CreateCommonSprite("board_pvpgoods.png", cc.p(100, 125+30)))
				local buyButton = CreateCommonButton("MainButton12.png", cc.p(100, 125-85), cc.size(137, 53), onItemClicked, {str = MultiLan("button_buy"),size=FontSize3})
				buyButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
				buyButton:setSwallowTouch(false)
				itemInfo.button = buyButton
				back:addChild(buyButton,0, (i-1)*3+j)
				
				local propInfo = GameData:getPropDataTable(itemInfo.prop_id)
				local itemObj = CreateBagItem()
				if itemInfo.attr ~= nil and itemInfo.attr ~= CJSON_NULL then
					itemObj:setItemType(BAG_ITEM_TYPE_HERO_EQUIP)
					itemObj:setItemInfoTable(itemInfo)
					itemObj:setCanTouch(false)
				else
					itemObj:setItemType(BAG_ITEM_TYPE_THING_SHOP)
					itemObj:setItemInfoTable(itemInfo)
					itemObj:setItemName("")
				end
				itemObj:setPosition(cc.p(100,125+58))
				back:addChild(itemObj)
				--vip
				if itemInfo.id == 1 then
					back:addChild(CreateCommonSprite("pic_vipicon.png", cc.p(100+55, 125+80)))
				end
				
				--打折
				if itemInfo.sale < 1 then
					if itemInfo.sale >= 0.5 then 
						back:addChild(CreateCommonSprite("pic_discount02.png", cc.p(100-22, 125+80)))
					else
						back:addChild(CreateCommonSprite("pic_discount01.png", cc.p(100-22, 125+80)))
					end
					local  saledes  = tostring(itemInfo.sale*100)
					if SDK_PLATFORM == "SDK_TGAME_TH_IOS" or SDK_PLATFORM == "SDK_TGAME_TH_ANDROID" then
						saledes  = tostring((1.0-itemInfo.sale)*100)
					end
					
					local saleLabel = CreateCommonLabel(string.format(MultiLan("shop_desc3"), saledes), cc.p(100-32, 125+90), FontSize2)
					saleLabel:setRotation(-30)
					back:addChild(saleLabel)
				end
				
				back:addChild(CreateCommonLabel(MultiLan(propInfo.name), cc.p(100, 125-8), FontSize2, cc.c3b(210, 0, 255)))
				if itemInfo.type == 1 then
					back:addChild(CreateCommonSprite("icon_silver.png", cc.p(100-38, 125-38),0.85))
				elseif itemInfo.type == 2 then
					back:addChild(CreateCommonSprite("icon_gold.png", cc.p(100-38, 125-38),0.85))
				elseif itemInfo.type == 6 then
					back:addChild(CreateCommonSprite("icon_drafts.png", cc.p(100-38, 125-38),0.85))
				end
				back:addChild(CreateCommonLabel(itemInfo.cost, cc.p(100+24, 125-37), FontSize2))
			end
		end
	
		y = y- 250
	end

	layer:setContentSize(cc.size(600, math.max(535, 250*line-20)))
	shopScrollLayer = layer
	scrolView:setContentOffset(cc.p(0, 535-(250*line-20)))
	shopScrollView = scrolView
	if 250  * line - 20 < 535 then
		scrolView:setTouchEnabled(false)
	end
end

local function ShopLayerInit()
	print("ShopLayerInit")

	if bShopInited then
		return
	end
	bShopInited = true
	--文字
	XiaLayerOwner["mShopDesc1"]:setColor(EQUIP_COLOR_ARR[4])
	XiaLayerOwner["mShopDesc1"]:setString(MultiLan("shop_desc4"))
	XiaLayerOwner["mShopDesc2"]:setColor(COLOR_WHITE)
	XiaLayerOwner["mShopDesc2"]:setString(MultiLan("shop_desc5"))

	XiaLayerOwner["mShopButtonRefresh"]:setTitleForState(MultiLan("button_refresh"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mShopButtonBuyAll"]:setTitleForState(MultiLan("shop_desc6"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mShopButtonBuyGold"]:setTitleForState(MultiLan("shop_desc7"), cc.CONTROL_STATE_NORMAL)
	
end

function ShopEnter()
	ShopLayerInit()
	
	ShopUpdateList()
	XiaLayerOwner["mCommonMoneyLayer"]:setVisible(true)
	SetCommonMoneyLayer()
end

function ShopExit()
	XiaLayerOwner["mCommonMoneyLayer"]:setVisible(false)
end

--购买全部
local function onShopBuyAll()
	if LuckShopLock then
		return
	end

	local function sendBuyAll()
		HttpSend("shop/buy", {"id=3", "all=1"}, shopBuyCallback)
	end
	
	if UserSelfInfo.vip == 0 and table.maxn(UserShopInfo.info.list)==1 and UserShopInfo.info.list[1].id == 1 then
		CommonNote(MultiLan("shop_desc2"))
		return
	end
	
	local canBuyOne = false
	for k,v in pairs(UserShopInfo.info.list) do
		if v.id ~= 1 or (v.id ==1 and true) then
			if v.type == 1 and UserSelfInfo.gold >= v.cost then
				canBuyOne = true
				break
			elseif v.type == 2 and UserSelfInfo.cash >= v.cost then
				canBuyOne = true
				break
			end
		end
	end
	
	if canBuyOne then
		CreateSmallPopupWithCancel("buyall", CreateCommonLabel(MultiLan("shop_desc8"), nil, FontSize3), sendBuyAll)
	else
		CommonNote(MultiLan("shop_desc9"))
	end
end

--购买次数
local function onShopBuyGold()
	local popupContent = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
	popupContent:addChild(CreateCommonSprite("pic_bigbox.png", Pos(POPUP_SIZE_MID, 0.5, 0.5)) )
	
	local sprite = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MID,0.5,0.9))
	sprite:setScaleX(1.4)
	popupContent:addChild(sprite)
	popupContent:addChild(CreateCommonLabel(MultiLan("shop_desc10"),Pos(POPUP_SIZE_MID,0.5,0.9), FontSize4, COLOR_CYAN))
	
	sprite = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MID, 0.46, 0.79))
	sprite:setScaleX(1.2)
	popupContent:addChild(sprite)
	popupContent:addChild(CreateCommonLabel(string.format(MultiLan("shop_desc11"), UserVipInfo.level, UserVipInfo.buy_gold), Pos(POPUP_SIZE_MID,0.12,0.79), FontSize4, COLOR_GREEN,cc.p(0,0.5)))
	
	popupContent:addChild(CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MID, 0.5, 0.4)))
	popupContent:addChild(CreateCommonLabel(MultiLan("prop_name_100002")..": "..UserSelfInfo.level*(2000+1500*math.floor(GameData:getGameDataTable().consume[UserShopInfo.buy_gold+1].buy_gold/50)), Pos(POPUP_SIZE_MID,0.5,0.4), FontSize4, COLOR_ORANGE))
	
	popupContent:addChild(CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MID, 0.5, 0.3)))
	popupContent:addChild(CreateCommonLabel(MultiLan("shop_desc12")..": "..GameData:getGameDataTable().consume[UserShopInfo.buy_gold+1].buy_gold, Pos(POPUP_SIZE_MID,0.5,0.3), FontSize4, EQUIP_COLOR_ARR[4]))
	
	popupContent:addChild(CreateCommonLabel(MultiLan("shop_desc13")..(UserVipInfo.buy_gold - UserShopInfo.buy_gold), Pos(POPUP_SIZE_MID,0.9,0.2), FontSize4, nil,cc.p(1,0.5)))
	
	local popupRoot = CommonCreatePopupMid("buysilver", popupContent, true)
	--购买全部按钮
	local function buyGoldCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("shopBuyCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		UserShopInfo.buy_gold = jsonDataTable.data.count
		UserInfo:addProp(jsonDataTable.data.prop)
		CommonNote(MultiLan("prop_name_100002").." +"..jsonDataTable.data.prop[1].num)
		UserSelfInfo[jsonDataTable.data.use_type] = UserSelfInfo[jsonDataTable.data.use_type] - jsonDataTable.data.use_num
		if jsonDataTable.data.use_type == "cash" then
			UseCash(jsonDataTable.data.use_num)
		end
		--刷新
		removeSelf(popupRoot)
		SetCommonMoneyLayer()
		onShopBuyGold()
	end
	
	local function sendBuyAll() 
		if UserVipInfo.buy_gold - UserShopInfo.buy_gold <= 0 then
			CommonTodayLimit()
			return
		end
		--判断钻石
		local comsumeData = GameData:getGameDataTable().consume
		local costCash = 0
		for i = UserShopInfo.buy_gold + 1, UserVipInfo.buy_gold do
			costCash = costCash + comsumeData[i].buy_gold
		end
		
		if costCash > UserSelfInfo.cash then
			CommonCashNeed()
		else
			HttpSend("shop/gold", {"all=1"}, buyGoldCallback)
		end
	
	end
	popupContent:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MID, 0.3, 0.08), cc.size(158,67), sendBuyAll, {str=MultiLan("shop_desc6"),size=FontSize3}))

	--购买按钮
	local function sendBuy() 
		if UserVipInfo.buy_gold - UserShopInfo.buy_gold <= 0 then
			CommonTodayLimit()
			return
		end
		
		if UserSelfInfo.cash <=  GameData:getGameDataTable().consume[UserShopInfo.buy_gold+1].buy_gold then
			CommonCashNeed()
		else
			HttpSend("shop/gold", {}, buyGoldCallback)
		end
	end
	popupContent:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_MID,0.7,0.08), cc.size(158,67), sendBuy, {str=MultiLan("button_buy"), size=FontSize3}))
end

--刷新商店
local function onShopRefresh()
	if LuckShopLock then
		return
	end

	local function shopRefreshCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			cclog("shopRefreshCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		UserSelfInfo[jsonDataTable.data.use_type] = UserSelfInfo[jsonDataTable.data.use_type] - jsonDataTable.data.use_num
		if jsonDataTable.data.use_type == "cash" then
			UseCash(jsonDataTable.data.use_num)
		end
		UserShopInfo.info.list = jsonDataTable.data.info.list
		table.sort(UserShopInfo.info.list,SortTableById)
		UserShopInfo.refresh_num =  jsonDataTable.data.refresh_num
		ShopUpdateList()
		SetCommonMoneyLayer()
		CommonNote(MultiLan("shop_desc14"))
	end

	local function sendShopRefresh()
		if UserSelfInfo.cash < GameData:getGameDataTable().consume[UserShopInfo.refresh_num + 1].cash_shop then
			CommonCashNeed()
			return
		end
		HttpSend("shop/refresh", {"id=3"}, shopRefreshCallback)
	end
	
	if GameData:getGameDataTable().consume[UserShopInfo.refresh_num + 1] == nil then
		CommonTodayLimit()
	else
		CreateSmallPopupWithCancel("surere", CreateCommonLabel(string.format(MultiLan("shop_desc15"), GameData:getGameDataTable().consume[UserShopInfo.refresh_num + 1].cash_shop), nil, FontSize3), sendShopRefresh)
	end
end


XiaLayer["onShopBuyAll"]       = onShopBuyAll
XiaLayer["onShopBuyGold"]      = onShopBuyGold
XiaLayer["onShopRefresh"]      = onShopRefresh