G_SOCKETTCP = nil

TCP_NETWORK_NOT_CONNECTED = 0
TCP_NETWORK_CONNECTED = 1
--TCP_NETWORK_CONNECTING = 2
TCP_NETWORK_ERROR = 3

TcpNetworkStatus = TCP_NETWORK_NOT_CONNECTED

function socketInit()  
    local socket = require("lua/socket")  
    local host = GameConfig.GetChatAddress() --"168.63.254.140"  
    local port = GameConfig:GetChatPort() --8888  
    G_SOCKETTCP = socket.tcp()  
    local n,e = G_SOCKETTCP:connect(host, port)  
    print("connect return:",n,e)  
    G_SOCKETTCP:settimeout(0)  
end  
function socketClose()  
    G_SOCKETTCP:close()  
end  
function socketSend(sendStr)  
    G_SOCKETTCP:send(sendStr)  
end  
function socketReceive()
    local response, receive_status=G_SOCKETTCP:receive(2) 
	--cclog("receive status %s", receive_status)
	if receive_status ~= "closed" and receive_status ~= "Socket is not connected" then  
		if response then
			local lib = require"struct"
			local tmpLength = lib.unpack(">i2", response)
			cclog("tmpLength %d", tmpLength)
			local receiveRawData = G_SOCKETTCP:receive(tmpLength)
			--local newLib = require"struct"
			--local receiveData = newLib.unpack("s", receiveRawData)
			--cclog("length %d %d %s %s", tmpLength, string.len(tostring(receiveData)), receiveData, receiveRawData)
			local mp = require "lua/MessagePack"
			local infoTable = mp.unpack(tostring(receiveRawData))
			ChatLayer:ChatLayerReceiveInfo(infoTable)
		end
	else  
		TcpNetworkStatus = TCP_NETWORK_NOT_CONNECTED
	end  
end  